=== debian/control ===
Source: rock-master-19.06-simulation-mars-graphics
Section: science
Priority: extra
Maintainer: Rock Packaging Daemon <rock-dev@dfki.de>
Build-Depends: cdbs, debhelper (>= 8.0.0), pkg-config, dh-autoreconf, build-essential, cmake, libopencv-dev, libopenscenegraph-dev, rock-master-19.06-simulation-lib-manager, rock-master-19.06-simulation-mars-common-cfg-manager, rock-master-19.06-simulation-mars-common-graphics-osg-material-manager, rock-master-19.06-simulation-mars-common-graphics-osg-terrain, rock-master-19.06-simulation-mars-interfaces, rock-master-19.06-tools-configmaps
Standards-Version: 3.9.2
Homepage: http://rock-robotics.org
#Vcs-Git: git://git.debian.org/collab-maint/bla.git
#Vcs-Browser: http://git.debian.org/?p=collab-maint/bla.git;a=summary

Package: rock-master-19.06-simulation-mars-graphics
Architecture: any
Depends: ${shlibs:Depends}, rock-master-19.06-simulation-lib-manager, rock-master-19.06-simulation-mars-common-cfg-manager, rock-master-19.06-simulation-mars-common-graphics-osg-material-manager, rock-master-19.06-simulation-mars-common-graphics-osg-terrain, rock-master-19.06-simulation-mars-interfaces, rock-master-19.06-tools-configmaps, cmake, build-essential, libopencv-dev, libopenscenegraph-dev
Description: mars_graphics
 This library provides a 3d visualization through simple interfaces.
